import java.util.LinkedList;

import Jcg.geometry.Point_;

/**
 * @author Luca Castelli Aleardi (Ecole Polytechnique, INF562)
 * @version jan 2014
 */
public class SlowRangeSearch<X extends Point_> implements RangeSearch<X> {

	LinkedList<X> points;
	
	public SlowRangeSearch(LinkedList<X> points) {
		this.points=points;
	}
	
	/**
	 * Linear time search (brute-force search)
	 * Useful for point clouds of small size
	 */
	public LinkedList<X> OrthogonalRangeSearch(X q, double sqRad) {
		LinkedList<X> res = new LinkedList<X>();
		if(q==null)
			return res;
		
		for (X p: this.points)
			if (q.squareDistance(p).doubleValue() < sqRad)
				res.add(p);
		return res;
	}
	
	public String toString() {
		return "Brute-force search";
	}
	
}
