import java.awt.image.BufferedImage;
import java.util.LinkedList;

import Jcg.geometry.Point_;
import Jcg.geometry.Point_2;
import Jcg.geometry.Point_3;
import Jcg.viewer.old.Fenetre;

/**
 * Testing input/output operations on point clouds and image files
 * 
 * @author Luca Castelli Aleardi and Steve Oudot (Ecole Polytechnique, INF562)
 * @version 2014-20
 */
public class TestIO {

	public static void main(String[] args) {
		System.out.println("Exercice 0: preliminary tests");    
		if (args.length < 1) {
			System.out.println("Error: missing input argument");
			System.out.println("Usage: java TestIO inputfile");
			System.exit(0);
		}
		
		String filename=args[0]; // input dataset: either point cloud (.dat) or image file (.jpg, .png, .bmp)
		LinkedList points=null; // input point cloud
		int dimension=0; // dimension not defined yet: either 2 or 3
		
		if(filename.endsWith(".dat")) {
			System.out.println("Loading point cloud from data: "+filename);
			points=IO.pointsFromDataFile(filename);
		}
		else {
			throw new Error("Error: wrong input format");
		}

		dimension=((Point_)points.getFirst()).dimension();
		if(dimension==2) {
			LinkedList<Point_2> points2D=(LinkedList<Point_2>)points;
			Draw.draw2D(points2D, "input point cloud");
		}
		else if(dimension==3) {
			LinkedList<Point_3> points3D=(LinkedList<Point_3>)points;
			Draw.draw3D(points3D);
		}
		
		if(points==null || points.size()==0)
			throw new Error("Error: the point cloud is empty or not defined");
		
		System.out.println("Point cloud: "+points.size()+" points");
		System.out.println("Space dimension: "+dimension);
	}  

}
