import java.util.LinkedList;

import Jcg.geometry.Point_;
import Jcg.geometry.Point_2;
import Jcg.geometry.Point_3;
import Jcg.geometry.Point_d;

/**
 * This class contains methods for testing the Kd-tree data structure
 * 
 * @author Luca Castelli Aleardi (Ecole Polytechnique, INF562)
 * @version jan 2020
 */
public class TestKdTree {

	public static void main(String[ ] args) throws Exception {
		System.out.println("Exercice 1.: testing Kd-trees construction");
		LinkedList points=null;
		KdTree kdTree=null;
		int dimension=0; // not defined

		if (args.length < 1) {
			points=(LinkedList<Point_2>)PointSetUtil.randomPointsOnAnnulus(1000, 1.0);
			kdTree=new KdTree<Point_2>(points); // construct the Kd-tree for the 2D case
			dimension=2;
			
		}
		else { 
			points=IO.pointsFromDataFile(args[0]);
			
			dimension=((Point_)points.getFirst()).dimension();
			if(dimension==2) kdTree=new KdTree<Point_2>(points); // construct the Kd-tree for the 2D case
			else if(dimension==3) kdTree=new KdTree<Point_3>(points); // construct the Kd-tree for the 3D case
			else kdTree=new KdTree<Point_d>(points); // construct the Kd-tree for the d-dimensional case
		}
		
		testConstructionKdTree(points, kdTree); // check the Kd-tree
		// draw the input point set
		if(dimension==2) {
			Draw.draw2D(points, "original point cloud");
			Draw.draw2DTree(kdTree, "kd-tree");
		}

	}
	
	public static void testConstructionKdTree(LinkedList points, KdTree tree) {
		System.out.println("Checking correctness of the Kd-Tree:");
		if(points==null) return;

		System.out.println("\t size original point cloud: "+points.size());
		System.out.println("\t size Kd-Tree (total number of nodes): "+KdTreeNode.size(tree.root));
		System.out.println("\t number of leaves in the tree: "+KdTreeNode.leavesNumber(tree.root));
		KdTreeNode.checkBalance(tree.root);
		System.out.println("test done.");
	}

}
